#pragma once
 
using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Diagnostics;
using namespace Extensibility;
using namespace System::Windows::Forms;
using namespace System::Runtime::InteropServices;
 
namespace AdxHT_007_VC
{
    //Add-in Express Add-in Module
    [GuidAttribute("71CB0E73-49C9-440E-9F36-220AFD13C052"), ProgId("AdxHT_007_VC.AddinModule")]
    __gc public class AddinModule : public AddinExpress::MSO::ADXAddinModule
    {
    public:
        AddinModule(void): AddinExpress::MSO::ADXAddinModule()
        {
            InitializeComponent();
        }
        AddinModule(System::ComponentModel::IContainer *container) : components(0)
        {
            /// <summary>
            /// Required for Windows.Forms Class Composition Designer support
            /// </summary>
 
            container->Add(this);
            InitializeComponent();
        }
 
        System::ComponentModel::IContainer* GetContainer()
        {
            return components;
        }
 
        void UninstallControls()
        {
            AddinExpress::MSO::ADXAddinModule::UninstallControls();
        }
 
        [ComRegisterFunctionAttribute]
        static void AddinRegister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        static void AddinUnregister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXUnregister(t);
        }
 
    protected:
        void Dispose(Boolean disposing)
        {
            if (disposing && components)
            {
                components->Dispose();
            }
            __super::Dispose(disposing);
        }
	private: System::Windows::Forms::ImageList *  imageList1;
	private: System::ComponentModel::IContainer *  components;

    private:
        /// <summary>
        /// Required designer variable.
        /// </summary>

 
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        void InitializeComponent(void)
        {
			this->components = new System::ComponentModel::Container();
			System::Resources::ResourceManager *  resources = new System::Resources::ResourceManager(__typeof(AdxHT_007_VC::AddinModule));
			this->imageList1 = new System::Windows::Forms::ImageList(this->components);
			// 
			// imageList1
			// 
			this->imageList1->ImageSize = System::Drawing::Size(16, 16);
			this->imageList1->ImageStream = (__try_cast<System::Windows::Forms::ImageListStreamer *  >(resources->GetObject(S"imageList1.ImageStream")));
			this->imageList1->TransparentColor = System::Drawing::Color::Transparent;
			// 
			// AddinModule
			// 
			this->AddinName = S"OlExample7 (VC)";
			this->Description = S"ADX2 Run-Time Example (VC)";
			this->Images = this->imageList1;
			this->SupportedApps = AddinExpress::MSO::ADXOfficeHostApp::ohaOutlook;
			this->OnError += new AddinExpress::MSO::ADXError_EventHandler(this, AddinModule_OnError);
			this->AddinFinalize += new AddinExpress::MSO::ADXEvents_EventHandler(this, AddinModule_AddinFinalize);
			this->AddinInitialize += new AddinExpress::MSO::ADXEvents_EventHandler(this, AddinModule_AddinInitialize);

		}
	private: System::Void AddinModule_OnError(AddinExpress::MSO::ADXErrorEventArgs *  e)
			 {
                 e->Handled = true;
				 MessageBox::Show(e->ADXError->Message, e->ADXError->Source, MessageBoxButtons::OK, MessageBoxIcon::Error);
			 }

	private: System::Void AddinModule_AddinFinalize(System::Object *  sender, System::EventArgs *  e)
			 {
			 }

    private: void DoClick(System::Object *  sender)
			 {
					 switch ( Convert::ToInt32(__try_cast<AddinExpress::MSO::ADXCommandBarButton*>(sender)->Tag) )
                 {
                     case 10:
						 MessageBox::Show(__try_cast<AddinExpress::MSO::ADXCommandBarButton*>(sender)->Caption);
                         break;
                     case 20:
						 MessageBox::Show(__try_cast<AddinExpress::MSO::ADXCommandBarButton*>(sender)->Caption);
                         break;
                     case 30:
						 MessageBox::Show(__try_cast<AddinExpress::MSO::ADXCommandBarButton*>(sender)->Caption);
                         break;
                     case 40:
						 MessageBox::Show(__try_cast<AddinExpress::MSO::ADXCommandBarButton*>(sender)->Caption);
                         break;
                 }

			 }

    private: void DoChange(System::Object *  sender)
			 {
				 switch ( Convert::ToInt32(__try_cast<AddinExpress::MSO::ADXCommandBarControl*>(sender)->Tag) )
                 {
                     case 100:
						 MessageBox::Show(__try_cast<AddinExpress::MSO::ADXCommandBarEdit*>(sender)->Text);
                         break;
                     case 200:
						 MessageBox::Show(__try_cast<AddinExpress::MSO::ADXCommandBarDropDownList*>(sender)->Text);
                         break;
                     case 300:
						 MessageBox::Show(__try_cast<AddinExpress::MSO::ADXCommandBarComboBox*>(sender)->Text);
                         break;
                 }

			 }

	private: AddinExpress::MSO::ADXOlExplorerCommandBar* adxCommandBar;
	private: System::Void AddinModule_AddinInitialize(System::Object *  sender, System::EventArgs *  e)
			 {
				 adxCommandBar = new AddinExpress::MSO::ADXOlExplorerCommandBar(this->components);
                 adxCommandBar->CommandBarName = S"ADX2 Command Bar (how to add controls) (VC)";
				 adxCommandBar->CommandBarTag = S"98F5C4AB-BA0A-469c-A02E-C2C9431B8E9F";
				 AddinExpress::MSO::ADXCommandBarButton* adxNewButton;
				 adxNewButton = new AddinExpress::MSO::ADXCommandBarButton(this->components);
				 adxCommandBar->Controls->Add(adxNewButton);
				 if (adxNewButton != 0)
				 {
                     adxNewButton->ControlTag = S"ADX2_RT_TAG1_VC";
                     adxNewButton->Temporary = true;
                     adxNewButton->Tag = S"10";
					 adxNewButton->Style = AddinExpress::MSO::ADXMsoButtonStyle::adxMsoButtonIconAndCaption;
                     adxNewButton->Caption = S"Button 1";
                     adxNewButton->Image = 0;
					 adxNewButton->ImageTransparentColor = System::Drawing::Color::White;
					 adxNewButton->Click += new AddinExpress::MSO::ADXClick_EventHandler(this, DoClick);
				 }

				 AddinExpress::MSO::ADXCommandBarEdit* adxNewEdit;
				 adxNewEdit = new AddinExpress::MSO::ADXCommandBarEdit(this->components);
                 adxCommandBar->Controls->Add(adxNewEdit);
                 if (adxNewEdit != 0) 
		         { 
                     adxNewEdit->ControlTag = S"ADX2_RT_TAG2_VC";
                     adxNewEdit->Temporary = true;
                     adxNewEdit->Tag = S"100";
                     adxNewEdit->Text = S"Text";
					 adxNewEdit->add_Change(new AddinExpress::MSO::ADXChange_EventHandler(this, DoChange));
		         }

				 AddinExpress::MSO::ADXCommandBarDropDownList* asxNewDropDownList;
				 asxNewDropDownList = new AddinExpress::MSO::ADXCommandBarDropDownList(this->components);
                 adxCommandBar->Controls->Add(asxNewDropDownList);

				 if (asxNewDropDownList != 0) 
				 {
                     asxNewDropDownList->ControlTag = S"ADX2_RT_TAG3_VC";
                     asxNewDropDownList->Temporary = true;
                     asxNewDropDownList->Tag = S"200";

					 String* myArr1[] = { S"Item 1", S"Item 2", S"Item 3"};
					 asxNewDropDownList->Items->AddRange(myArr1);
                     asxNewDropDownList->ListIndex = 1;
					 asxNewDropDownList->Change += new AddinExpress::MSO::ADXChange_EventHandler(this, DoChange);
				 }

				 AddinExpress::MSO::ADXCommandBarComboBox* adxNewComboBox;
				 adxNewComboBox = new AddinExpress::MSO::ADXCommandBarComboBox(this->components);
				 adxCommandBar->Controls->Add(adxNewComboBox);
				 if (adxNewComboBox != 0) 
				 {
                     adxNewComboBox->ControlTag = S"ADX2_RT_TAG4_VC";
                     adxNewComboBox->Temporary = true;
                     adxNewComboBox->Tag = S"300";
					 String* myArr2[] = { S"Item 1", S"Item 2", S"Item 3"};
                     adxNewComboBox->Items->AddRange(myArr2);
                     adxNewComboBox->ListIndex = 2;
                     adxNewComboBox->Change += new AddinExpress::MSO::ADXChange_EventHandler(this, DoChange);
				 }

				 AddinExpress::MSO::ADXCommandBarPopup* adxNewPopup;
				 adxNewPopup = new AddinExpress::MSO::ADXCommandBarPopup(this->components); 
                 adxCommandBar->Controls->Add(adxNewPopup);
                 if (adxNewPopup != 0) 
				 {
                     adxNewPopup->ControlTag = S"ADX2_RT_TAG5_VC";
                     adxNewPopup->Temporary = true;
                     adxNewPopup->Caption = S"Popup";

					 AddinExpress::MSO::ADXCommandBarButton* adxNestedButton;
					 adxNestedButton = new AddinExpress::MSO::ADXCommandBarButton(this->components);
                     adxNewPopup->Controls->Add(adxNestedButton);
                     if (adxNestedButton != 0) 
					 {
						 adxNestedButton->ControlTag = S"ADX2_RT_TAG6_VC";
                         adxNestedButton->Temporary = true;
                         adxNestedButton->Tag = S"20";
                         adxNestedButton->Caption = S"Button 2";
					     adxNestedButton->Click += new AddinExpress::MSO::ADXClick_EventHandler(this, DoClick);
				     }
            
					 adxNestedButton = new AddinExpress::MSO::ADXCommandBarButton(this->components);
					 adxNewPopup->Controls->Add(adxNestedButton);
                     if (adxNestedButton != 0) 
					 {
                         adxNestedButton->ControlTag = S"ADX2_RT_TAG7_VC";
                         adxNestedButton->Temporary = true;
                         adxNestedButton->Tag = S"30";
                         adxNestedButton->Caption = S"Button 3";
					     adxNestedButton->Click += new AddinExpress::MSO::ADXClick_EventHandler(this, DoClick);
					 }

					 adxNestedButton = new AddinExpress::MSO::ADXCommandBarButton(this->components);
					 adxNewPopup->Controls->Add(adxNestedButton);
                     if (adxNestedButton != 0) 
					 {
                         adxNestedButton->ControlTag = S"ADX2_RT_TAG8_VC";
                         adxNestedButton->Temporary = true;
                         adxNestedButton->Tag = S"40";
                         adxNestedButton->Caption = S"Button 4";
					     adxNestedButton->Click += new AddinExpress::MSO::ADXClick_EventHandler(this, DoClick);
					 }
				 }

			 }
	};
}

